
#include<Arduino.h>
//#include <ESP8266WiFi.h>
#include <ESP8266WebServer.h>
//#include <WiFiClient.h>
//#include <ESP8266mDNS.h>
#include <Wire.h>
#include <U8g2lib.h>

U8G2_SSD1306_128X64_NONAME_F_SW_I2C
u8g2(U8G2_R0, /* clock=*/ 12, /* data=*/ 14, /* reset=*/ U8X8_PIN_NONE);   // All Boards without Reset of the Display

const int buttonPin = 0;     // the number of the pushbutton pin
int audio8 = 2;      // output audio on pin 13
int note = 800;      // music note/pitch
int led1 = 4;
int led2 = 5;
int treshold = 300;
int buttonState = 0; 
int count = 0; 
String alarmon; 
String alarmoff;
float t;
 
/*Put your SSID & Password*/
const char* ssid = "nome della tua rete Wifi";
const char* password = "password della tua rete WiFi";
ESP8266WebServer server(80);              
  
void setup() {
  u8g2.begin();
  Serial.begin(115200);   
  while (!Serial){
    count++;
    delay(100);
    if (count >= 20) break;
     }
  pinMode(buttonPin, INPUT);
  pinMode(led1, OUTPUT);
  pinMode(led2, OUTPUT);
  delay(100);
   
  Serial.println("Connecting to ");
  Serial.println(ssid);
 
  WiFi.begin(ssid, password);
 
  while (WiFi.status() != WL_CONNECTED) {
  delay(500);
  Serial.print(".");
  }
  Serial.println("");
  Serial.println("WiFi connected..!");
  Serial.print("Got IP: ");  Serial.println(WiFi.localIP());
 server.send(200, "text/html", SendHTML(t)); 
  u8g2.clearBuffer();
  u8g2.setFont(u8g2_font_7x14B_tr);
  u8g2.drawStr(10, 60, "IP:");
  u8g2.drawStr(35, 60, WiFi.localIP().toString().c_str());
  server.on("/", handle_OnConnect);
  server.onNotFound(handle_NotFound);
 
  server.begin();
  Serial.println("HTTP server started");
}

void loop() {
  server.handleClient();}
  
void handle_OnConnect() {
  server.send(200, "text/html", SendHTML(t)); 
  u8g2.clearBuffer();
  u8g2.setFont(u8g2_font_7x14B_tr);
  u8g2.drawStr(10, 60, "IP:");
  u8g2.drawStr(35, 60, WiFi.localIP().toString().c_str());

  buttonState = analogRead(buttonPin);
  if (buttonState < treshold) {
    tone(audio8, note);
    digitalWrite(led1, HIGH);
    digitalWrite(led2, LOW);
    Serial.println("switch non attivo");
    u8g2.drawStr(10, 10, "switch non attivo");
    u8g2.drawStr(10, 30, "                 ");
    u8g2.sendBuffer();
    alarmon = "PORTA APERTA!!!";
    alarmoff = "                   ";

  } else {
    // turn Speaker off:
    noTone(audio8);
    digitalWrite(led1, LOW);
    digitalWrite(led2, HIGH);
    Serial.println("switch attivato  ");
    u8g2.drawStr(10, 30, "switch attivato  ");
    u8g2.drawStr(10, 10, "                 ");
    u8g2.sendBuffer();
    alarmoff = "Porta chiusa";
    alarmon = "                 ";
  }

  Serial.println(buttonState);
  //server.handleClient();
  delay(300);
}

void handle_NotFound(){
  server.send(404, "text/plain", "Not found");
}
String SendHTML(float t){
  String ptr = "<!DOCTYPE html> <html>\n";
  ptr +="<head><meta http-equiv=\"refresh\" content=\"2\">\n";
  ptr +="<title>ESP8266 Weather Station</title>\n"; 
  ptr +="<style>html { font-family: Helvetica; display: inline-block; margin: 0px auto; text-align: center;}\n";
  ptr +="body{margin-top: 50px;} h1 {color: #000099;margin: 50px auto 30px;}\n";
  ptr +="p {font-size: 24px;color: #33cc00;margin-bottom: 10px;}\n";
  ptr +="t {font-size: 30px;color: #ff0000;margin-bottom: 10px;}\n";
  ptr +="</style>\n";
  ptr +="</head>\n";
  ptr +="<body>\n";
  ptr +="<div id=\"webpage\">\n";
  ptr +="<h1>Controllo porta di casa</h1>\n";
  ptr +="<p>.";
  ptr +=alarmoff;
  ptr +="<p/> ";  
  ptr +="<t>.";
  ptr +=alarmon;
  ptr +="<t/> "; 
  ptr +="</div>\n";
  ptr +="</body>\n";
  ptr +="</html>\n";
  return ptr;
}
